/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>
#include <dtct16.h>

void dtct16()
{
 //printk("Module DTCT16 ...",i_blanc);
 //printk(" OK\n",cli_i_vert);

 printk("\nBastKernel version 0.0.1\n",i_cyan); 
 putchr(196,cyan,maxcol);

 //remplir les lments de la super structure
  
 strcpy((char _fptr *)cpu.nom_cpu,(char _fptr *)init_cpu(0));
 strcpy((char _fptr *)cpu.id_cpu,(char _fptr *)init_cpu(1));

 unsigned long _fptr *ptr=(unsigned long _fptr *)init_cpu(2);

 cpu.frqcpu.faible_frq_cpu=*ptr++;
 cpu.frqcpu.fort_frq_cpu=*ptr;
                         
 //RAM
 ram.extd_ram=init_ram(0);
 ram.base_mem=init_ram(1);

                        //affichage des lments de la super structure

 //CPU
 print("\nCPU Dtecte: ");
 printk((const char _fptr *)cpu.nom_cpu,i_blanc);

 print("  ID: ");
 printk (hexascinv((const char _fptr *)cpu.id_cpu,2),i_blanc);

 print("   Frquence: ");
 printk(decasc(cpu.frqcpu.faible_frq_cpu/54926),i_blanc);
 printk("MHz\n",i_blanc);

 //Mmoire

 print("Total mmoire tendue: ");
 printk(decasc(ram.extd_ram),i_blanc);
 printk("K\n",i_blanc);

 print("Total mmoire Conventionnelle: ");
 printk(decasc(ram.base_mem),i_blanc);
 printk("K\n",i_blanc);

                                             
 bascul(bascul_adr);                        //Mise en place du basculeur 16-bit
 unsigned int config=0;

 asm{int 0x11
    mov word ptr config,ax}                //recupre la configuration de la machine
 superstruct->initconfig.config=config;

    #include <disq16.h>                   //Dtction des disques et chargement de la partie 32-bit
                                                   
 asm{
    mov dx,0x92                         
    in al,0x92
    or al,2
    out dx,al                            // activer la ligne A20
    }
 asm{
    mov ah,03
    mov al,05
    mov bx,0
    int 0x16                            //taux de delai de rp des touches clavier est max
    }; 

 /* FFFF:0010 quivaut  0x100000 aprs activation de la ligne A20
  * car 0xffff*0x10+0x10=0x100000(adresse linaire)
  */

 memncpy((char _fptr *)0x90000000,(char _fptr*)0xFFFF0010,3*512*nbr_sect_charger);

 print("Initialisation de la GDT ...\n");
 init_gdt(adr_init_gdt);                            //  4000h:0000 

 print("Passage en mode protg ...\n");
 mod_prtg((unsigned long)0x100000); /*passe en mode protg et fait un saut au parametre */

}
