.model tiny,c
.data
gdtr dw 0
     dd 0

gdt_nul dq 0                ; reserv par Intel

KR_CS       dw 0ffffh       ; 08 est le descripteur du segment de code 
            dw 00000        ; du noyau
            db 00           ; Base=0  limit=0xfffff*4Ko 
            db 09Ah         ;
            db 0CFh         ; Le 0xC exprime un segment avec Limit en page et de type 32-bit
            db 00           ;

KR_DS       dw 0FFFFh
            dw 00000        ; 0x10
            db 00
            db 92h
            db 0CFh
            db 00

KR16_CS          dw 0ffffh
                 dw 00000
                 db 00      ;0x18
                 db 9ah
                 db 0fh
                 db 00

KR16_DS          dw 0ffffh
                 dw 00000    ;0x20
                 db 00
                 db 92h
                 db 0fh
                 db 00

USER_CS          dw 0ffffh   ;0x28          DPL=3 alors CS_USER=0x2B
                 dw 00000
                 db 00                     ; CODE SEGMENT USER
                 db 0FAh
                 db 0CFh
                 db 00

USER_DS          dw 0ffffh    ;0x30         DPL=3 alors DS_USER=0x33
                 dw 00000                   ;DATA SEGMENT USER
                 db 00
                 db 0F2h
                 db 0cfh
                 db 00

KR_TACHE         db  8  dup(0)  ; 0x38      la tche noyau
SCHED_TACHE      db  8  dup(0)  ; 0x40      la tche de l'ordonnanceur
LDT              db  8  dup(0)  ; 0x48      la ldt par dfaut, pour les processus.

reserver         db 8*4  dup(0)             ;on reserve 4 segments pour une
                                            ;ventuelle utilisation

TACHES           db 8*256 dup(0)   ;0x70    pour grer 256 processus avec chacun
                                   ;        un descripteur-TSS.

gdt_end          dq 0              ;0x870

.code
  .386p
init_gdt proc uses si di adr:dword ;adr reprsente l'adresse o doit tre initialise la gdt
  cli ; 
  cld ;si et di seront incrm"
  mov bx,offset gdt_nul
  mov ax,offset gdt_end
  sub ax,bx ;           ax=taille de la table GDT

  mov si,offset gdt_nul
  les di,dword ptr adr
  mov cx, ax ;taille de la gdt
  rep movsb
  mov word ptr gdtr,ax
  ;adr est donne en seg:offset (16-bit) nous devons la transformer en adresse lineaire
  mov eax,dword ptr adr
  mov ebx,eax
  and ebx,0ffffh      ; on obtient l'offset du (seg:offset)
  and eax,0ffff0000h  ; le seg
  mov cl,12
  shr eax,cl          ; dcalage de eax vers la droite de 12 bits
  add eax,ebx         ; on ajoute l'offset pour avoir l'adresse lineaire dans eax
  mov dword ptr gdtr+2,eax


  lgdt fword ptr gdtr
sti
ret
init_gdt endp
end
