#include <kernel.h>

#define adr_stack            0xFFFFFFFC            // adresse virtuelle de la pile, Attention: en changeant cette valeur, penser  changer  reel_stack, de faon  avoir la mme fin
#define adr_process          0x10000000

#define reel_stack           ((adr_stack)&0xFFF)   // valeur qu'on ajoute  l'adresse relle de la page pour avoir le dbut de la pile (sens dcroissant)

#define KR_TACHE             0x38                //voir "..\16\init_gdt.asm": pour + de dtails
#define SCHED_TACHE          0x40
#define ldt0                 0x48
#define tache0               0x70                     // index dans la gdt de la 1re tache.

#define max_tache            256
#define max_semaphore        32
#define taille_tss           0xff        // sur i386 elle est de 104 octets, on posera une valeur plus grande (255), l'essentiel est de dpasser 104


#define charger_segments  tache[i].tss.cs=USER_CS; \
                          tache[i].tss.ds=USER_DS; \
                          tache[i].tss.es=USER_DS; \
                          tache[i].tss.ss=USER_DS; \
                          tache[i].tss.gs=USER_DS; \
                          tache[i].tss.fs=USER_DS                                  


typedef struct tss_struct{    /* le contexte hardware d'une tche, dfinit par intel*/
   u16 link;u16 res0;         //dans ce qui suit res# signifie rserv par intel
   u32 esp0; u16 ss0; u16 res1;
   u32 esp1; u16 ss1; u16 res2; u32 esp2;
   u16 ss2; u16 res3; u32 cr3;  u32 eip; u32 eflags; u32 eax,ecx,edx,ebx;
   u32 esp,ebp; u32 esi,edi; u16 es, res4; u16 cs, res5;u16 ss, res6;
   u16 ds, res7; u16 fs, res8;u16 gs, res9; u16 ldt,res10; u16 ts; u16 io_map;
   u32 io_per[33];
   u16 tr;
            }tss_struct;

typedef struct mem_struct{
                   u32 *pgd;
                   u32 *pgt;     //on aura qu'une seule table de page, d'o cette dclaration
                   u16 nbr_pgt;  //nombre d'entres dans la table des pages.

                   u32 *debut;
                   u32 taille;
                   char droit;
                      struct stack{
                             u32 *debut1;  //adresse physique de la 1ere page de pile
                             u32 *debut2;  //et de la 2eme
                             u8 nbr_pge;
                                  }stack;
                   }mem_struct;

enum type {serveur,periodique,aperiodique};
typedef struct schedule
              {
                   struct tache *succ;    // successeur du processus en cours
                   struct tache *pred;    // et son prdecesseur.
                   TIME cpt_ci;      // dcrement  chaque top d'horloge.
                   DATE cpt_ri;
                   DATE ri;    // date de reveil pour les tches temps reel (ri).
                   TIME ci;    // duree d'excution de la tche (Ci).
                   TIME pi;    // periode d'excution pour les tches priodiques (Pi).
                   u32 Bi;
                   enum type type;
                    struct ressource
                             {
                               u16 magic;  //0xFAFA pour la prsence
                               u16 file;   //numro de la file de l'ensemble des smaphores  utiliser
                               SEMAPHORE attente;
                             }ressource;
                     
              }sched;

enum etat {pret,suspendu,delai,sem,termine,attente};

struct tache{
             tss_struct  tss;
             char nom[32];
             u16 id;
             u16 priorite;
             u16 temp_pr;   // sauver la priorit en cas de rehaussement en SC
             enum etat etat;
             mem_struct  mem;
             sched  sched;
             u16 magic;
            };

struct semaphore{
           u16 id;
           u16 id_tache;      // id de la tche qui dtient la ressource associe
           u8 val;           // valeur du semaphore
           u16 priorite;      // priorite plafonne
           SEMAPHORE succ;
           SEMAPHORE pred;
           u16 magic;

           SEMAPHORE nsucc[max_semaphore];   // pour pouvoir associer une file de semaphores
           SEMAPHORE npred[max_semaphore];   //  chaque tche
           u32 time[max_semaphore];          // dure de la section critique associe

                };

struct temp_pile_tache{
            u32 buffer_stack[510];   //environement de pile pour executer le processus 0
            u32 debut;
                };
struct temp_pile_int{
            u32 buffer_stack[510];   //environement de pile pour executer les interruptions
            u32 debut;
                };

struct pile_aperiodique{
         u32 buffer[124];   //  chaque arrive d'une apriodique son adresse est empile ici.
         u32 bottom;
              };

struct entete_file
    {
      TACHE tete;
      TACHE queue;
      u16  cpt;           //compte le nombre processus existant dans la liste
    };
struct file_sem
    {
      SEMAPHORE tete;
      SEMAPHORE queue;
      u16 cpt;
    };
 extern struct tache tache[max_tache];
 extern struct tache kernel;
 extern struct tache scheduler;
 extern struct semaphore semaphore[max_semaphore];
 extern struct file_sem file_sem[max_semaphore], file_sem_courant;

 extern struct temp_pile_tache temp_pile_tache;
 extern struct temp_pile_int   temp_pile_int;

 extern struct entete_file file_semaphore[max_semaphore],file_pret_periodique,
               file_pret_tpartage,file_serveur;

 extern struct pile_aperiodique pile_aperiodique;

