/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>

#define quantum        100         // 100Hz
#define horloge_8254   1193180     // 1193180Hz


void init_timer()
{ 
print("Initialisation du Timer... ");

 asm
    {

     mov al,0xb4 //0x34            // 0011 x10 0
                            // 00:selection du conteur 0,
                            // 11:(bits du conteur)  poids faibles puis pds forts
                            // x10: selection du mode 2 (gnrer une pulsation aprs chaque priode)
                            // 0:conteur binaire
     out 43h,al
     jmp $+2
    
 /* le 8254 (timer) dcremente le conteur avec une cadence de: 1193180Hz
  * nous allons focer  prsent le compteur, pour avoir un quantum  100Hz.
  * pour ce faire, on introduira la valeur 1193180Hz/100Hz dans le conteur
  * et comme programm dj dans le port de contrle 43h, on introduira les faibles poids
  * puis les plus forts poids
  */

    };

  u32 cpt=((horloge_8254)/(quantum));
  unsigned char p_faible=((cpt)& 0xff),p_fort=(cpt>>8);

   asm
      {
       mov al,p_faible
       out 42h,al
       jmp $+2

       mov al,p_fort
       out 42h,al
       jmp $+2
      };

print("%dHz\n",quantum);
}


