/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>
#include <proc.h>

u16 id_max_prio=0,          // sauvegarde l'identit de la tche priodique la + prioritaire.
    id_min_ri=0,            // sauvegarde l'identit de la tche  avec le + proche temps de rveil.
    id_min_ri_sans_srvr=0,     // sauvegarde l'identit de la tche  avec le + proche temps de rveil hormis le serveur.
    id_serveur=-1;           // sauvegarde l'identit serveur.

float facteur_U=0;          // sauvegarde la somme cumule ci/pi
u16 nbr_tache_periodique=0,   // contient le nombre de tches periodiques
    nbr_tache_aperiodique=0;  // contient le nombre de tches apriodiques

u8 nbr_tache_serveur=0,         // pour eviter la creation de +ieurs serveurs
   utilisation_ressource=0;     // s'il y a utilisation de ressources

int etat_serveur=0;
extern u8 signal_aperiodique;
extern void nop_thread();
u32 _esp_serveur;

struct semaphore semaphore[max_semaphore];
struct file_sem file_sem[max_semaphore];
struct file_sem file_sem_courant;

// Le suivant tableau contient,
// des valeurs calcules de : n*((2^(1/n)) - 1)

float tableau_RM[23]={1.0000, 0.8284,  0.7797, 0.7568, 0.7434, 0.7347, 0.7286, 0.7240, 0.7205, 0.7177, 
                      0.7154, 0.7135, 0.7119, 0.7105, 0.7094, 0.7083, 0.7074, 0.7066, 0.7059, 0.7052,
                      0.7047, 0.7041, 0.7036};

struct tache tache[max_tache];

/**********************************************************************************************************/



int condition_RM(TIME ci, TIME pi, TIME Bi, int indice)
{
  float f1=ci, f2=pi, f3=Bi,   // pour convertir ci pi et Bi en nombre rel.
  i=facteur_U+(f1/f2);

  //if (Bi) print("(ci/pi + Bj/Pj)=%d Bi=%d tableau_RM[%d]: 0,%d\n",(u32)((i+(f3/f2))*1000),Bi,indice,(u32)(tableau_RM[indice]*1000));
   //      else print("ci/pi=%d tableau_RM[%d]: 0,%d\n",(u32)(ci*1000)/pi,indice,(u32)(tableau_RM[indice]*1000));

  if ((i+(f3/f2))<=tableau_RM[indice])
     {
       facteur_U=i;
       return 0;
     }
   else return -1;
}

/**************************************************************************************/

u32 determiner_Bi(u16 id)      // le protocole PCP: temps de blocage [TH95]
{
  u16 tab[max_semaphore],file1,file2;
  u16 *ptr=&tab[0], *temp=&tab[0];
  u32 max;

  TACHE t=file_pret_periodique.tete;
  SEMAPHORE s,ss;

if (t)         // si la file contient un lment
 {
  do
   {
    if ((t->priorite<=tache[id].priorite) &&  // considrer les tches - prio"
         (t->id!=id))
     {
      if (t->sched.ressource.magic==0xFAFA) //cette tche utilise ressources ?
        {
         file1=tache[id].sched.ressource.file;
         file2=t->sched.ressource.file;
         s=file_sem[(t->sched.ressource.file)].tete; //s pointe vers la file des semaphores de la tche: t
         ss=file_sem[(tache[id].sched.ressource.file)].tete; // ss pointe vers la file des semaphores de la tche: tache[id]
         do                                  // vrifier si "t" a des ressources communes avec tache[id]
           {
            do
             {
              if (ss==s)           // ressource commune
                {
                 if (s->priorite>=tache[id].priorite) //considrer les ressource dont la prio" plaf" >= pr de la tache id
                   {
                             *temp++=s->id;     //on sauvegarde  alors la ressource dans le tableau tab
                             *temp++=file2;     //et la file associe.
                   }
                }
             }while((s=s->nsucc[file2])!=0);
            s=file_sem[(t->sched.ressource.file)].tete; //s pointe de nouveau vers la file des semaphores de la tche: t
           }while((ss=ss->nsucc[file1])!=0);
        }                               // fin si utilise des ressources.
     }                                  // fin si tches - prioritaires.
   }while((t=t->sched.succ)!=0);

  if (temp==&tab[0]) //aucune ressource commune trouve
      return 0;
    
  else
   {
    for (max=0;ptr<temp;ptr+=2)  // determiner le max des dures des sections critiques.
      {
      // print("Bi1=%d  ",max);
       if (max<semaphore[*ptr].time[*(ptr+1)])
                     max=semaphore[*ptr].time[*(ptr+1)];
      // print("  Bi2=%d\n",max);
      }
     //print("**********\n");
    return max;
   }
 }
return 0;
}

/**********************************************************************************/

int get_tache_libre()
{
  u16 i=0;
  for(;i<max_tache;i++)
    if (tache[i].magic!=0xBABA) return i;
return -1;   // pas de contexte libre trouv.
}

u8 __serveur=0;

get_min_ri(u16 id, DATE ri)
{
  if (tache[id_min_ri].sched.ri==ri)
     {
      if (tache[id_min_ri].priorite<tache[id].priorite)
         {
          id_min_ri=id;
           if (__serveur==0) //l'id n'est pas ce du serveur.
              id_min_ri_sans_srvr=id;
          }
     }
  else if (tache[id_min_ri].sched.ri>ri)
          {
           id_min_ri=id;
           if (__serveur==0) 
              id_min_ri_sans_srvr=id;
          }
return 0;
}

/******************************************************************************************/

void set_priorite_plafond()
{
 u16 file;
 TACHE t=file_pret_periodique.tete;
 SEMAPHORE s;
if(t)             // si la file contient un lment.
 {
  do
    {
      if (t->sched.ressource.magic==0xFAFA) // si la tche utilise des ressources (signature)
        {
         s=file_sem[(t->sched.ressource.file)].tete;
         file=t->sched.ressource.file;
         do{
         if ((s->priorite)<(t->priorite))
           { s->priorite=t->priorite;      //le semaphore reoit le max des priorit des tches  parcourir
           //print("semaphore.b.[%d].pr=%d\n",s->id,s->priorite);
           }
           }while((s=s->nsucc[file])!=0);
        }
    }while((t=t->sched.succ)!=0);
 }

}

/*******************************************************************************************************************/

void set_priorite(u16 id, TIME pi) // affecte une priorit  la tche:[id] et met  jour les autres priorits.
{
u16 temp_pi=0,
temp_pr=0;
struct tache *p=file_pret_periodique.tete;

if (nbr_tache_periodique)  // s'il existe des tches priodiques
  {
   if (pi<=(tache[id_max_prio].sched.pi))
       {
         if (pi==(tache[id_max_prio].sched.pi))
               tache[id].priorite=tache[id_max_prio].priorite;           
          else 
               {
                tache[id].priorite=tache[id_max_prio].priorite+1;
                id_max_prio=id;
               }
       }
   else
       {                         /* parcourir toute la file pour avoir la + petite                            periode immdiatement superieure  pi */
              do{
                 if (pi==p->sched.pi)
                    {
                          temp_pr=p->priorite;
                          temp_pi=pi;
                     }
                 else

                 if (pi>p->sched.pi)
                  {
                      if (temp_pi<=p->sched.pi)
                        {
                          temp_pi=p->sched.pi;
                          temp_pr=p->priorite;
                        }
                   p->priorite++;
                  }
                }while((p=p->sched.succ)!=0);
              tache[id].priorite=temp_pr;
       }
  }
else     // si c'est la premire tche priodique  inserer dans la file.
   {
      tache[id].priorite=1;
      id_max_prio=id;
   }

}  // fin set_priorite

/******************************************************************************************************/

void init_file_sem()
{
 u16 i;
 for (i=0;i<=max_semaphore;i++)
  {
   file_sem[i].tete=(SEMAPHORE)NULL;
   file_sem[i].queue=(SEMAPHORE)NULL;
   file_sem[i].cpt=0;
  }
}

/*******************************************************************************************/

int get_sem_libre()
{
 int i;
 for (i=0;i<max_semaphore;i++)
  {
   if (semaphore[i].magic!=0xBABA) return i;
  }
 return -1;
}

/*****************************************************************************************************/

int add_semaphore(u16 num_file,SEMAPHORE sem,u32 time)
{
  SEMAPHORE ptr;
  if (file_sem[num_file].tete==(SEMAPHORE)NULL)    //si c'est le 1er semaphore  inserer
    {
    file_sem[num_file].tete=sem;
    file_sem[num_file].queue=sem;
    file_sem[num_file].cpt++;
    sem->time[num_file]=time;
    sem->nsucc[num_file]=(SEMAPHORE)NULL;
    sem->npred[num_file]=(SEMAPHORE)NULL;
    return 0;
    };
//sinon
   ptr=file_sem[num_file].queue;
   ptr->nsucc[num_file]=sem;
   sem->time[num_file]=time;
   sem->npred[num_file]=ptr;
   sem->nsucc[num_file]=(SEMAPHORE)NULL;        //indiquer le dernier de la liste

   file_sem[num_file].queue=sem;  //la queue va pointer sur le deriner lment
   file_sem[num_file].cpt++;
return 0;
}

/*******************************************************************************************************/

SEMAPHORE creer_semaphore()
{
 int i;
 if ((i=get_sem_libre())==-1) return (SEMAPHORE)NULL;       // pas d'espace 
 semaphore[i].val=1;
 semaphore[i].id=i;
 semaphore[i].magic=0xBABA;
 semaphore[i].priorite=0;
 print_rt("->Cration du smphore [%d]\n",i);
 return &semaphore[i];
}

/************************************************************************************************************/

int creer_tache(THREAD thread, DATE ri, TIME ci, TIME pi,u16 num_file_sem)
{
int i;
if (__serveur){
             print_rt("  ->Crer Serveur (Ci=%d et Pi=%d)\n",ci,pi);
             goto suite;
             }
if (pi)
  print_rt("Tentative de crer une Priodique (Ci=%d et Pi=%d)\n",ci,pi);
else
  print_rt("Tentative de crer une apriodique: (Ci=%d)\n",ci);

suite:
if ((i=get_tache_libre())==-1) return -1;     // pas d'espace libre pour le contexte.
print_rt("   ->Espace dans la Structure des tche trouv, numro [%d]\n",i);
if (pi)                                    // il s'agit d'une tche priodique.
  {
      if ((file_sem[num_file_sem].tete)&&    // Utilisation des ressources
          (num_file_sem<=max_semaphore))
        {
           print_rt("   ->La tche priodique [%d] est susceptible d'utiliser des ressources\n",i);
           utilisation_ressource=1;
           tache[i].sched.ressource.magic=0xFAFA; //la tche i utilise des ressources
           tache[i].sched.ressource.file=num_file_sem; // la file associe.
        }

      tache[i].id=i;
      tache[i].sched.pi=pi;
      tache[i].etat=pret;
      tache[i].sched.ri=ri;
      tache[i].sched.cpt_ri=ri;
      // la pile
      tache[i].tss.esp=(u32)(ADR_TACHE_STACK_TR -((i+1)*2048));
      u32 *exit=(u32 *)tache[i].tss.esp;
      *exit=(u32)nop_thread;      //valeur de retour de la thread i (vers nop_thread)

      tache[i].tss.eflags=0x200;
      tache[i].sched.type=periodique;
      tache[i].temp_pr=0;
      print_rt("Remplir le contexte de la tche [%d]:\n",i);
      print_rt("       ->ID, Pi, Etat=pret, Type=prio, Date de rveil, Compteur date rveil\n");
      print_rt("       ->Zone de pile: ESP=%X Contenu: %X [ADR nop_thread]\n",tache[i].tss.esp,*exit);
      /* les suivantes fonctions doivent respecter cet ordre d'excution*/

      set_priorite(i,pi);
      print_rt("   ->Dterminer la priorit suivant Rate Monotonic... Priorit:=%d\n",tache[i].priorite);
      get_min_ri(i,ri);      //trouver la + petite date de reveil var: id_min_ri
      print_rt("   ->Revaluer la plus petite date de rveil des tches... Tche[%d]\n",id_min_ri);
      add_file_pret(&tache[i],&file_pret_periodique);
      print_rt("   ->Ajouter la tche[%d]  la file des priodiques: %p\n",i,&file_pret_periodique);
      nbr_tache_periodique++;
   
  }
else       // il s'agit d'une tche apriodique.
  {
   tache[i].id=i;
   add_file_pret(&tache[i],&file_serveur);
   tache[i].sched.type=aperiodique;
   nbr_tache_aperiodique++;
   print_rt("Remplir le contexte de la tche apriodique [%d]:\n",i);
   print_rt("       ->ID, Type=apriodique\n");
   print_rt("   ->Ajouter la tche[%d] apriodique  la file Serveur: %p\n",i,&file_serveur);


  }
     tache[i].sched.ci=ci;
     tache[i].sched.cpt_ci=ci;  // compteur decrement  chaque top d'horloge.
     tache[i].tss.eip=(u32) thread;
     tache[i].magic=0xBABA;
     print_rt("Ajouter les informations suivantes au contexte:\n");
     print_rt("       ->Capcit, Compteur de capacit, TSS.EIP=Adresse de la thread\n");
     print_rt("       ->Signature du contexte(pris): 0xBABA\n");
     print_rt("=> La tche [%d] est alors cre\n\n",i);

return i;     // retourne l'identificateur de la tche cre.
}

/**************************************************************************************************************/

int faisabilite()
{
 u32 Bi;
 facteur_U=0;
 int i=0;                                       // valeur en us indiquant, le temps max de blocage d'une tche
 TACHE t=file_pret_periodique.tete;
 print_rt("Test de faisabilit Rate Monotonic en cours...\n");
if (t)
{
 if (utilisation_ressource)
     {
      print_rt("   Il y a utilisation de ressources dans le systme.\n");
          set_priorite_plafond();   //attribue pour chaque semaphore une priorit
      print_rt("      ->Attribuer les priorits plafonds pour chaque smaphore...[OK]\n");
      print_rt("      ->Dterminer le facteur de blocage pour chaque tche...\n");
      print_rt("      ->Test de faisiablit RM avec partage de ressources...\n");

     }
 else {
      print_rt("   Pas d'utilisation de ressources dans le systme\n");
      print_rt("      =>Test de faisiablit RM sans partage de ressources...\n");
      } 
 do
  {
      if (t->sched.ressource.magic!=0xFAFA) //pas d'utilisation de ressources
          {
             if (condition_RM(t->sched.ci,t->sched.pi,0,i)!=0)
                return -(t->id+1);   // test de faisabilit RM.
               
          }
       else    // Utilisation de ressources
          {
             Bi=determiner_Bi(t->id);        //calcul du facteur de blocage de la tche i
             if (condition_RM(t->sched.ci,t->sched.pi,Bi,i)!=0)         
                 return -(t->id+1);        //test de faisabilit RM avec facteur de blocage
             t->sched.Bi=Bi;
          }
  i++; 
  }while((t=t->sched.succ)!=0);

}
return 0;
}

/*******************************************************************************************************************/
int supprimer_semaphore(SEMAPHORE sem)
{
 sem->magic=0;
return 0;
}

/**************************************************************************************************************/

int supprimer_tache(u16 id)
{
 if (tache[id].sched.type==periodique)
   {
     rem_file_pret(&tache[id],&file_pret_periodique);
     nbr_tache_periodique--;
     facteur_U-=((float)tache[id].sched.ci/(float)tache[id].sched.pi);
   }
 else
   {
     rem_file_pret(&tache[id],&file_serveur);
     nbr_tache_aperiodique--;
   }
 tache[id].magic=0;
return 0;
}

/********************************************************************************************************************/

int creer_serveur(DATE ri, TIME ci, TIME pi)
{
int i;
print_rt("Tentative de crer un Serveur de tches apriodiques...\n");
if (etat_serveur) return -2;       //serveur dj cr
__serveur++;  //indique  get_min_ri que le traitement est particulier (serveur)

i=creer_tache((THREAD)&serveur_tache,ri,ci,pi,255); //255>max_semphore c'est pour justement viter d'utiliser des ressources poour cette tche.
__serveur--;

   if (i>=0)
   {
    etat_serveur=1;
    id_serveur=i;
    tache[id_serveur].sched.type=serveur;
    print_rt("       ->redfinir le type du serveur  serveur\n");
    _esp_serveur=tache[id_serveur].tss.esp;
    if (signal_aperiodique==0) tache[id_serveur].etat=suspendu;
   }
   else return i;
return i;
}
/***********************************************************************************************************/

void print_tache(struct tache *tache)
{
 print("Tache: Id=%d\n",tache->id);
 print("Infos hardware:\n");
 print("EAX=%X EBX=%X ECX=%X EDX=%X\n",tache->tss.eax,tache->tss.ebx,
                                       tache->tss.ecx,tache->tss.edx);                             
 print("ESI=%X EDI=%X EBP=%X ESP=%X\n",tache->tss.esi,tache->tss.edi,
                                       tache->tss.ebp,tache->tss.esp);

 print("EIP=%X EFLAGS=%X\n",tache->tss.eip,tache->tss.eflags);
 
 print("CS=%x DS=%x ES=%x SS=%x\n",tache->tss.cs,tache->tss.ds,tache->tss.es,
                                   tache->tss.ss);
 print("Etat de la pile:\n");
    u32 *ptr=(u32 *)tache->tss.esp; 
    u16 i;
    for (i=0;i<=0;i++,ptr++) 
      {
        print("[%p]:%p ptr=%p\n",ptr,*ptr);
      };
}
