/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>
#include <memory.h>
#include <proc.h>

struct entete_file file_pret_periodique={NULL,NULL,0},
                   file_pret_tpartage={NULL,NULL,0},
                   file_serveur={NULL,NULL,0};


/******************************************************************/
/*          ORDONNANCEMENT DES TACHES TEMPS REEL                  */
/******************************************************************/


struct tache nop_tr,   //contexte de la tche qui est sollicite lors d'absence d'une tche TR prte.
      *aperiodique_id=NULL;  // pointeur vers la tche apriodique lue

struct super_struct_setup *superstruct=(super_struct_setup *)0x10001;

u8 reinitialiser_serveur=0,aperiodique_suivante=1,
   signal_aperiodique=0;         //mis  1 lors de l'arrive d'une apriodique voir signaler_aperiodique() et dans ints.cpp

u8 etat_IT=1;
extern u8 it_timer;

extern u16 nbr_tache_periodique,
           nbr_tache_aperiodique,
           id_min_ri, id_min_ri_sans_srvr,id_serveur;

extern u32 _esp_serveur;

extern DATE cpt_absolu;
extern "C" u32 _esp;  ///voir it.asm: (int60)
int courant_id=-1;

struct pile_aperiodique pile_aperiodique;

u32 top_aperiodique=(u32)&pile_aperiodique.bottom,
    bottom_aperiodique=(u32)&pile_aperiodique.bottom;



void schedule_tr()
{
   struct tache *p;
   switch (courant_id)   
    {
     case -1:          // s'il s'agit de la premire excution du scheduler.

            nop_tr.tss.eip=(u32)&nop_thread;  // charger le contexte de la tche nop_thread pour une ventuelle utilisation
            nop_tr.tss.eflags=0x200;            
            nop_tr.tss.esp=ADR_TACHE_STACK_TR;

            if (tache[id_min_ri].sched.ri<=0)
                {
                   if(tache[id_min_ri].id==id_serveur)
                    {
                      p=get_aperiodique();  //affecte la var globale: aperiodique_id
                      if (p)
                        {
                         courant_id=id_serveur;
                         premiere_commutation(&tache[id_serveur]);
                         //print_rt("Premire excution: Tche serveur.\n");
                        }
                      else
                       {
                         if (tache[id_min_ri_sans_srvr].sched.type==periodique)
                          {
                            //print_rt("Premire excution: ID de la tche=%d\n",tache[id_min_ri_sans_srvr].id);
                            courant_id=id_min_ri_sans_srvr;
                            premiere_commutation(&tache[id_min_ri_sans_srvr]);
                          }
                       }
                     break;
                     }

                 courant_id=id_min_ri;
                 premiere_commutation(&tache[id_min_ri]);
                }
              //print_rt("Premire excution: ID de la tche=%d\n",courant_id);
            else
                {
                 premiere_commutation(&nop_tr);
                 courant_id=-2;
                }

            break;

     case -2:          // s'il s'agit d'un retour de la tche nop_thread. 
            get_aperiodique();
            if ((p=get_next_tache()))   // s'il existe une tche prte.
                  {
                      commuter(&nop_tr,p);
                      courant_id=p->id;
                  }
             //else print_rt("Creux temporel\n");

            break;

     default:         // tche periodique.

         get_aperiodique();  //affecte la var globale: aperiodique_id
         if((tache[courant_id].id==id_serveur)&& (aperiodique_id))
            {
                if (--aperiodique_id->sched.cpt_ci==0) //puisement de l'apriodique
                    {
                     aperiodique_id->sched.cpt_ci=aperiodique_id->sched.ci;
                     aperiodique_suivante|=1;
                     reinitialiser_serveur|=1; //indiquer  "commuter()" qu'il faut rinitialiser le serveur
                     //print_rt("Epuisement de l'apriodique: %d\n",aperiodique_id->id);
                     if (signal_aperiodique)
                             get_aperiodique();
                     else
                       tache[id_serveur].etat=suspendu; //suspendre le serveur.
                    }
            }


       if(--tache[courant_id].sched.cpt_ci==0) 
         {
          tache[courant_id].sched.cpt_ri+=
          /*(cpt_absolu-tache[courant_id].sched.ci)*/(tache[courant_id].sched.pi);  // +1, car le compteur abslou (cpt_absolu) est incrment bien avant
          tache[courant_id].sched.cpt_ci=tache[courant_id].sched.ci;
         }
       if ((p=get_next_tache()))   // s'il existe une tche + prioritaire prte.
                {
                  if (courant_id!=p->id)
                   {
                     //print_tache(p);
                     commuter(&tache[courant_id],p);
                     courant_id=p->id;

                   }
               //print_rt("Election de la tche: %d\n",courant_id);
                }
       else    {
                 commuter(&tache[courant_id],&nop_tr);  //sinon attendre.
                 courant_id=-2;
                //print_rt("Creux temporel\n");
               }
    }
}



THREAD __thread_aperiodique;
void serveur_tache()
{
    while(1)
     {
     if ((aperiodique_id!=0) && (tache[id_serveur].etat==pret))
           {
            __thread_aperiodique=(THREAD)aperiodique_id->tss.eip;
            if (__thread_aperiodique!=0)
                   asm call __thread_aperiodique;

            aperiodique_suivante|=1;   //aucune apriodique n'est en phase de traitement
            tache[courant_id].etat=suspendu;  //  on suspend le serveur

           }
      
    }
}

struct tache *get_next_tache()
{
 struct tache *p=file_pret_periodique.tete;
 int temp_pr=0, temp_id=-1;
 if (nbr_tache_periodique)    // s'il existe des tches periodiques.
   do {
       if (p->etat==attente)   //attente d'un semaphore
          {
           if (((SEMAPHORE)p->sched.ressource.attente)->val)  //si le semaphore est liber
                p->etat=pret;       //rendre la tche en "attente", prte;
          }

       if ((p->sched.cpt_ri<=(cpt_absolu-1))  //vrifier l'cheance
              &&((p->etat==pret)  // la tche  slectionner doit tre prte.
              || (p->etat==sem)))  // ou en SC
        {
         if (temp_pr<p->priorite)
           { temp_pr=p->priorite;
             temp_id=p->id;
           }
        }
      } while((p=p->sched.succ));
  if (temp_id!=-1)          // s'il existe une tche + prioritaire que celle en cours.
     return &tache[temp_id];
  else
  return NULL;
}

struct tache *get_aperiodique()
{
 struct tache *p=NULL;
 u32 *top=(u32 *)top_aperiodique;
 u32 *bottom=(u32 *)bottom_aperiodique;

 if(aperiodique_suivante) // s'il n y a pas d'apriodique en phase de traitement
  {
   if ((nbr_tache_aperiodique)&&(signal_aperiodique))
    {
      if (top!=bottom)  // si la file contient un lment.
        {
          p=(struct tache *)*bottom--;
          bottom_aperiodique=(u32)bottom;
          tache[id_serveur].etat=pret;  // le serveur rentre en concurence.
          aperiodique_id=p;
          aperiodique_suivante&=0;
          //print_rt("Depilement apriodique\n");//id=%d",p->id);
        }

      if (top==bottom) // plus de tches apriodiques
          {
           top_aperiodique=bottom_aperiodique=(u32)&pile_aperiodique.bottom;
           signal_aperiodique&=0;

           //print_rt("Pile apriodique vide! \n");
          }
     
    }
  }
return p;
}


void commuter(struct tache *pred, struct tache * succ)
 {
  /* Nous allons sauver le contexte de la tche (pred)
     et charger le contexte de la nouvelle tche (succ) */
   
   u32 * ptr=(u32 *)_esp,  //_esp indique le sommet de la pile lors de l'IT et
                           // aprs empilement du contexte, voir: it.asm : int60
       * pile=(u32 *)succ->tss.esp;


   pred->tss.edi=*(ptr++);        // sauvegarde du contexte
   pred->tss.esi=*(ptr++);
   pred->tss.ebp=*(ptr++);
   ptr++;                   // esp : voir ci dessous
   pred->tss.ebx=*(ptr++);
   pred->tss.edx=*(ptr++);
   pred->tss.ecx=*(ptr++);
   pred->tss.eax=*(ptr++);
   pred->tss.eip=*(ptr++);
   ptr++; //CS est toujours le mme (on travaille dans le mme niveau (noyau))
   pred->tss.eflags=*(ptr++);
   pred->tss.esp=(u32)ptr;       // sans inclure (eflags,cs,eip),
                                 //  ie: l'etat de la pile avant l'IT, les autres sont dpils par l'instruction popad
                                 // voir: it.asm (int60)

   if (reinitialiser_serveur)
      {
       tache[id_serveur].tss.eip=(u32)&serveur_tache;
       tache[id_serveur].tss.esp=_esp_serveur;
       tache[id_serveur].tss.eflags=0x200;
       reinitialiser_serveur&=0;
      }


   *(--pile)=succ->tss.eflags;    // empilement du contexte dans l'espace pile du succ
   *(--pile)=KR_CS;
   *(--pile)=succ->tss.eip;
   *(--pile)=succ->tss.eax;
   *(--pile)=succ->tss.ecx;
   *(--pile)=succ->tss.edx;
   *(--pile)=succ->tss.ebx;
   *(--pile)=succ->tss.esp;
   *(--pile)=succ->tss.ebp;
   *(--pile)=succ->tss.esi;
   *(--pile)=succ->tss.edi;

   _esp=(u32)pile;    // pour pouvoir changer l'@ de pile dans it.asm (int60)
 }

void premiere_commutation(struct tache * succ)
{
   u32 * ptr=(u32 *)succ->tss.esp;  
                           
   *(--ptr)=succ->tss.eflags;
   *(--ptr)=KR_CS;
   *(--ptr)=succ->tss.eip;

   _esp=(u32)(ptr-8);  //"popad" sera excute avant la sortie de l'IT, (pour avoir donc lors de l'iret, que, le contexte dfinit ci-dessus)
}

void nop_thread()         // elle est sollicite  chaque fois qu'il n y a pas
                          // de tche active.
{
 while(1);
}

void signaler_aperiodique(u16 id)
 {
    u32 * p=(u32 *)top_aperiodique;
  if (top_aperiodique>=(u32)&pile_aperiodique.buffer[0]) //pour viter le dbordement
   {
    signal_aperiodique|=1;
    *p--=(u32)&tache[id];
    top_aperiodique=(u32)p;
    //print_rt("signaler apriodique\n");

   }
 }

/**************************************************************************/
/*                        API TEMPS REEl POUR L'UTILISATEUR                          */
/**************************************************************************/
u32 frq_cpu;
extern struct super_struct_setup *superstruct;
#define cpu superstruct->initcpu


void activer_horloge()
{
print_rt("Activation de l'horloge temps rel... 1024tops/s\n\n->");
outpb(0x70,0xb);
outpb(0x71,inpb(0x71)|0x40); //activer les IT periodiques.
asm sti;
}

void suspendre_tache(u16 id)
{
 tache[id].etat=suspendu;
}

void suspendre_tache_courante()
{
 tache[courant_id].etat=suspendu;
}

void reprendre_tache(u16 id)
{
  tache[id].etat=pret;
}

u16 tache_courante()
{
 return courant_id;
}

etat etat_tache(u16 id)
{
 return tache[id].etat;
}

DATE get_absolute_time()
{
 return cpt_absolu;
}

DATE time2absolute(u8 h, u8 m, u8 s)
{
 return ((h*3600)+(m*60)+s)*NBR_IT_PERIO;  //par defaut il y a 1024 IT/s.
}

DATE date_sys2absolute(u8 h, u8 m, u8 s)
{
 DATE temp1,temp2;
 u8 hh=lire_heure(),
    mm=lire_minute(),
    ss=lire_seconde();

 if ((temp2=time2absolute(hh,mm,ss))>(temp1=time2absolute(h,m,s)))
    return temp2-temp1;
return 0;
}

void suspendre_tache_delai(TIME t)  // t est un temps exprim en us
{
 _rdtsc(t,frq_cpu,0,0); // 0,0: pour reserver un espace de pile: voir rdtsc.asm
}


/**********************************************************************/
/*                             TIME                                   */
/**********************************************************************/

 u8 lire_heure()
{
  u8 h;
  outpb(0x70,4);
  h=inpb(0x71);
  return ((h>>4)*10)+(h & 0x0F);    // conversion BCD en binaire pr
}
 u8 lire_minute()
{
  u8 m;
  outpb(0x70,2);
  m=inpb(0x71);
  return ((m>>4)*10)+(m & 0x0F);
}
 u8 lire_seconde()
{
  u8 s;
  outpb(0x70,0);
  s=inpb(0x71);
  return ((s>>4)*10)+(s & 0x0F);
}

 void __frq_cpu()
{           
       frq_cpu=(u32)(cpu.frqcpu.a+(cpu.frqcpu.b<<32))/54925;
}

 double rdtsc()
{
}

/***********************************************************************/
/*                          SEMAPHORES                                 */
/***********************************************************************/


void P(SEMAPHORE s)                  //la primitive P(s)
{

  SEMAPHORE p;
  u16 temp; 

asm cli;
print_rt("\n***** P(s[%d]) par Tche[%d]\n",s->id,courant_id);


boucler:
asm cli;
  if (s->val==0)                    //si la ressource est prise
    {
     if (tache[courant_id].priorite > tache[(temp=s->id_tache)].priorite)
           {
                //la tche qui dtient "s" hrite
                //de la priorit de de la tche courante (si sa prio est <)
              print_rt("    PCP ->Hritage de priorit: tache[%d] de tache[%d] (pr=%d) \n",temp,courant_id,tache[courant_id].priorite);
    
              tache[temp].temp_pr=tache[temp].priorite;
              tache[temp].priorite=tache[courant_id].priorite;
           }
     tache[courant_id].etat=attente;
     tache[courant_id].sched.ressource.attente=s;

     asm sti;
     while(s->val==0);         //tant que la ressource est prise boucler
    };

 /* PCP: Protocole  Priorits Plafonnes */

 p=file_sem_courant.tete;
   if (p)
      {
        do
         {
           if (p->id_tache!=courant_id)    //ne vrifier que, les ressources alloues pour les autres tches
             {
               if (!(s->priorite>p->priorite)) //et si prio de la ressource sollicite n'est pas > pr plafond des autres
                   {
                      asm cli;
                      print_rt("    PCP ->Attendre la libration du smaphore %d dtenu par la tache[%d]\n",p->id,p->id_tache);
                      if (tache[courant_id].priorite >
                                          tache[(temp=p->id_tache)].priorite)
                       {
                         //la tche qui dtient "s" hrite
                         //de la priorit de de la tche courante (si sa prio est <)
                  
                         print_rt("    PCP ->Hritage de priorit: tche[%d] de tche[%d] (Priorit:%d)\n",temp,courant_id,tache[courant_id].priorite);
                         tache[temp].temp_pr=tache[temp].priorite;
                         tache[temp].priorite=tache[courant_id].priorite;
                       }
                         tache[courant_id].etat=attente;  //informer les scheduler de l'attente
                         tache[courant_id].sched.ressource.attente=p; //du semaphore p
                       
                       asm sti;
                       while(p->val==0);   //attendre la libration de la ressource
                       goto boucler;       //pour revrifier l'tat de la file
                   }
             }
         }while((p=p->succ));
      }

 asm cli;
 s->val=0;    //allouer la ressource

   print_rt("    ->Allocation de ressource par le smaphore [%d]\n",s->id);
 

 s->id_tache=courant_id;  //pour la tche courante
 tache[courant_id].etat=sem;
 add_sem_file(s,&file_sem_courant); // et l'ajouter  la file des SEM
  
    print_rt("    ->Ajout du smaphore[%d]  la file des smaphores courants: %p\n",s->id,&file_sem_courant);
 asm sti;
}

/**********************************************************************************************/

void V(SEMAPHORE s)
 {
  asm cli;
   print_rt("\n***** V(s[%d]) par Tche[%d] \n",s->id,courant_id);

   u16 temp=s->id_tache;
   if (tache[temp].temp_pr)  // s'il y a eu rehaussement de priorit
      {
   
       print_rt("   PCP ->Restauration de la priorit de tache[%d]  %d\n",temp,tache[temp].temp_pr);

       tache[temp].priorite=tache[temp].temp_pr; //restaurer la priorit d'origine
       tache[temp].temp_pr=0;
      }
     rem_sem_file(s,&file_sem_courant); // on retire "s" de la file
  
       print_rt("   ->Retirer le smaphore [%d] de la file des smaphores courants: %p\n",s->id,&file_sem_courant);
  

   tache[temp].etat=pret;
   s->val=1;

       print_rt("   ->Libration du smaphore [%d]\n",s->id);
   asm sti;
 }
 
/***************************************************************************************************/


int add_sem_file(SEMAPHORE s,struct file_sem *entete)    //ajouter un SEM dans une file
 {
  SEMAPHORE ptr;
  if (entete->tete==(SEMAPHORE)NULL)        //si c'est la 1er semaphore  inserer
    {
    entete->tete=s;
    entete->queue=s;
    entete->cpt++;
    s->succ=(SEMAPHORE)NULL;
    s->pred=(SEMAPHORE)NULL;
    return 0;
    };
//sinon
   ptr=entete->queue;
   ptr->succ=s;

   s->pred=ptr;
   s->succ=(SEMAPHORE)NULL;                     //indiquer le dernier de la liste

   entete->queue=s;          //la queue va pointer sur le deriner lment
   entete->cpt++;
 }

/**************************************************************************************************************/

int rem_sem_file(SEMAPHORE s,struct file_sem *entete)   //supprimer de la liste, un processus
 {
    SEMAPHORE ptr;
    if (entete->tete==(SEMAPHORE)NULL) return -1;       //erreur: aucun lment  supprimer

    if (((s->pred)==(SEMAPHORE)NULL)                  //si c'est le seul dans la file
       && ((s->succ)==(SEMAPHORE)NULL)) 
       {
       entete->tete=(SEMAPHORE)NULL;
       entete->queue=(SEMAPHORE)NULL; entete->cpt=0;
       return 0;
       }

    ptr=s->pred;

    if (ptr!=(SEMAPHORE)NULL)                    //si ce n'est pas le premier dans la file
    {
    ptr->succ=s->succ;

    ptr=s->succ;
      if (ptr!=(SEMAPHORE)NULL)                 //si ce n'est pas le dernier de la file
           ptr->pred=s->pred;
      else entete->queue=s->pred;           //si c'est le dernier, mettre  jour la queue

     }

    else    // si c'est le premier
      {
         ptr=s->succ;
         ptr->pred=(SEMAPHORE)NULL;
         entete->tete=s->succ;
         
      }

   entete->cpt--;
   return 0;
 }


/*********************************************************************************************/


int add_file_pret(struct tache *tache,struct entete_file *entete)    //ajouter une tche dans une file
 {
   struct tache *ptr;

  if (entete->tete==NULL)        //si c'est la 1re "tche"  inserer
    {
    entete->tete=tache;
    entete->queue=tache;
    entete->cpt++;
    tache->sched.succ=NULL;
    tache->sched.pred=NULL;
    return 0;
    };
//sinon
   ptr=entete->queue;
   ptr->sched.succ=tache;

   tache->sched.pred=ptr;
   tache->sched.succ=NULL;                     //indiquer le dernier de la liste

   entete->queue=tache;          //la queue va pointer sur le deriner lment
   entete->cpt++;
 }

int rem_file_pret(struct tache *tache,struct entete_file *entete)                //supprimer de la liste, un processus
 {
    struct tache *ptr;
    if (entete->tete==NULL) return -1;       //erreur: aucun lment  supprimer

    if (((tache->sched.pred)==NULL)                  //si c'est le seul dans la file
       && ((tache->sched.succ)==NULL)) 
       {
       entete->tete=NULL;
       entete->queue=NULL; entete->cpt=0;
       return 0;
       }

    ptr=(struct tache *)tache->sched.pred;

    if (ptr!=NULL)                    //si ce n'est pas le premier dans la file
    {
    ptr->sched.succ=tache->sched.succ;

    ptr=tache->sched.succ;
      if (ptr!=NULL)                 //si ce n'est pas le dernier de la file
           ptr->sched.pred=tache->sched.pred;
      else entete->queue=tache->sched.pred;           //si c'est le dernier, mettre  jour la queue

     }

    else    // si c'est le premier
      {
         ptr=tache->sched.succ;
         ptr->sched.pred=NULL;
         entete->tete=tache->sched.succ;
         
      }

   entete->cpt--;
   return 0;
 }

